;; Scatole cinesi per TS
;; MPradella 20060622

(require (file "/home/pradella/docs/2d/satts/satts.scm"))

(define gamma* '(u d l r 1 2 3 4))
(set-gamma! *gamma*)


(define *tiles*
   (tiling-ec
     (lambda (i j k l)
	     (and
	      (impl (member i '(u 1))
		    (member j '(u 2)))

	      (impl (member j '(r 2))
		    (member l '(r 4)))

	      (impl (member l '(d 4))
		    (member k '(d 3)))

	      (impl (member k '(l 3))
		    (member i '(l 1)))))
     *gamma*))
	      
(display (length *tiles*))(newline)
(set-tiles! *tiles*)

(set-inverse-pi!
  '((o   u d l r )
    (x   1 2 3 4 ))
  )

(define q
  '(($ $ $ $ $ $)
    ($ x o o x $)
    ($ o x x o $)
    ($ o x x o $)
    ($ o x x o $)
    ($ o x x o $)
    ($ x o o x $)
    ($ x o o x $)
    ($ o x x o $)
    ($ o x x o $)
    ($ x o o x $)
    ($ $ $ $ $ $)))

(please-parse-it q)

