;; Blob Dyckiano (variante con tile esplicite)
;; MPradella, 20060620

(require (lib "42.ss" "srfi"))
(require (file "/home/pradella/docs/2d/satts/satts.scm"))


(define *gamma* '("\\nwarrow" "\\nearrow" "\\swarrow" "\\searrow" "   "))
(set-gamma! *gamma*)

(define *gamma1* (cons '$ *gamma*))


(set-tiles!
  (let ((t #f))
    
    (list-ec (: i *gamma1*)(: j *gamma1*)
	     (: k *gamma1*)(: l *gamma1*)
	     
	     (begin
	       (set! t (list (list i j)
			     (list k l))))

	     (or
	      (equal? t '(("\\searrow" "\\nearrow")
			  ("\\swarrow" "\\nwarrow")))
	      (equal? t '(("\\nwarrow" "\\swarrow")
			  ("\\nearrow" "\\searrow")))
	      (equal? t '(("\\searrow" "\\nearrow")
			  ("\\nearrow" "\\searrow")))
	      (equal? t '(("\\nwarrow" "\\swarrow")
			  ("\\swarrow" "\\nwarrow")))

	      
	      (equal? t '(("\\nearrow" "\\nwarrow")
			  ("\\searrow" "\\swarrow")))
	      (equal? t '(("\\swarrow" "\\searrow")
			  ("\\nwarrow" "\\nearrow")))

	     (and
	      ; (not
; 	       (equal? t '(("\\nearrow" "\\searrow")
; 			   ("\\nwarrow" "\\swarrow"))))
; 	      (not
; 	       (equal? t '(("\\swarrow" "\\nwarrow")
; 			   ("\\searrow" "\\nearrow"))))

	      (impl (equal? i "\\searrow")
		    (only-one 
		     (equal? j "\\nearrow")
		     (equal? k "\\swarrow")
		     (equal? l "\\searrow")))
	      (impl (equal? i "\\nwarrow")
		    (only-one 
		     (equal? j "\\swarrow")
		     (equal? k "\\nearrow")
		     (equal? l "\\nwarrow")))
	      
	      (impl (equal? j "\\swarrow")
		    (only-one 
		     (equal? i "\\nwarrow")
		     (equal? k "\\swarrow")
		     (equal? l "\\searrow")))
	      (impl (equal? j "\\nearrow")
		    (only-one 
		     (equal? i "\\searrow")
		     (equal? k "\\nearrow")
		     (equal? l "\\nwarrow")))
	      
	      (impl (equal? k "\\nearrow")
		    (only-one 
		     (equal? i "\\nwarrow")
		     (equal? j "\\nearrow")
		     (equal? l "\\searrow")))
	      (impl (equal? k "\\swarrow")
		    (only-one 
		     (equal? i "\\searrow")
		     (equal? j "\\swarrow")
		     (equal? l "\\nwarrow")))
	      
	      (impl (equal? l "\\nwarrow")
		    (only-one 
		     (equal? i "\\nwarrow")
		     (equal? j "\\nearrow")
		     (equal? k "\\swarrow")))
	      (impl (equal? l "\\searrow")
		    (only-one 
		     (equal? i "\\searrow")
		     (equal? j "\\swarrow")
		     (equal? k "\\nearrow")))))
	     t)))




(set-inverse-pi!
  '((o   "   ")
    (_   "\\nwarrow" "\\nearrow" "\\swarrow" "\\searrow"))
  )


(define p0
  '(($ $ $ $ $ $ $ $ $ $ $ $)
    ($ o o o o o o o o o o $)
    ($ o o o o o o o o o o $)
    ($ o o o _ _ _ _ o o o $)
    ($ o o _ o o o _ o o o $)
    ($ o _ o o o _ _ _ o o $)
    ($ o _ _ _ _ _ o _ o o $)
    ($ o o _ _ _ _ _ _ o o $)
    ($ o o _ o _ o _ _ o o $)
    ($ o o o _ _ _ _ o o o $)
    ($ o o o o _ _ o o o o $)
    ($ o o o o o o o o o o $)
    ($ o o o o o o o o o o $)
    ($ $ $ $ $ $ $ $ $ $ $ $)
    ))



; fig 6
(please-parse-it p0)

