;;;-----------------------------------------------

(define *gamma* '(u d l r 1 2 3 4 _))

(define *tiles*
  (tiles-of
   '(($ $ $ $ $ $ $ $)
     ($ _ _ _ _ _ _ $)
     ($ _ 1 u u 2 _ $)
     ($ _ l _ _ r _ $)
     ($ _ l _ _ r _ $)
     ($ _ 3 d d 4 _ $)
     ($ _ _ _ _ _ _ $)
     ($ $ $ $ $ $ $ $))))
 

(define *inverse-pi*
  '((o   _)
    (x   1 2 3 4 u d l r))
  )

(for-each 
  (lambda (size)
    (newline)
    (display "going for ")
    (display size)
    (newline)
    (system "rm -f out.*")
    (parse-it *tiles* *gamma* *inverse-pi* (big-picture-of size 'o))
    (system "cat enter; ls -l out.*"))
  '(50 60 70 80 90 100 110 120))
